<?php


namespace App\Http\Controllers;

use App\Models\Orders;
use FedEx\ShipService\ComplexType\Address;
use FedEx\ShipService\ComplexType\ClientDetail;
use FedEx\ShipService\ComplexType\Contact;
use FedEx\ShipService\ComplexType\Dimensions;
use FedEx\ShipService\ComplexType\LabelSpecification;
use FedEx\ShipService\ComplexType\Party;
use FedEx\ShipService\ComplexType\Payment;
use FedEx\ShipService\ComplexType\Payor;
use FedEx\ShipService\ComplexType\ProcessShipmentRequest;
use FedEx\ShipService\ComplexType\RequestedPackageLineItem;
use FedEx\ShipService\ComplexType\RequestedShipment;
use FedEx\ShipService\ComplexType\VersionId;
use FedEx\ShipService\ComplexType\WebAuthenticationCredential;
use FedEx\ShipService\ComplexType\WebAuthenticationDetail;
use FedEx\ShipService\ComplexType\Weight;
use FedEx\ShipService\Request;
use FedEx\ShipService\SimpleType\DropoffType;
use FedEx\ShipService\SimpleType\LabelFormatType;
use FedEx\ShipService\SimpleType\LabelStockType;
use FedEx\ShipService\SimpleType\LinearUnits;
use FedEx\ShipService\SimpleType\PackagingType;
use FedEx\ShipService\SimpleType\PaymentType;
use FedEx\ShipService\SimpleType\RateRequestType;
use FedEx\ShipService\SimpleType\ServiceType;
use FedEx\ShipService\SimpleType\ShippingDocumentImageType;
use FedEx\ShipService\SimpleType\WeightUnits;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Response;

class DeliverySytemsController extends Controller
{
    public $successStatus = 200;


    public function getFedexData($id)
    {


//        $orderId = $data['order_id'];97 Quentin Rd, 1st floor, Brooklyn, NY 11223

        $order = Orders::find($id);
        $sender = \App\Models\Address::select([
            'id',
            'user_id',
            'scan_id',
            'firstname',
            'secondname',
            'fathername',
            'phone',
            'street',
            'house',
            'passport',
            'passport_by',
            'passport_issue',
            'apartment',
            'zip',
            'is_default',
            'type',
            'created',
            DB::raw('(select title_uz from country where id = address_info.country) as country'),
            DB::raw('(SELECT (sum(orders.amount)-1000)*(-1) FROM orders where orders.to_address_id=address_info.id) as r_limit'),
            DB::raw('(select title_uz from city where id = address_info.city) as city')
        ])->where([
            ['id', '=', $order->from_address]
        ])->get();


        if ($order == null) {
            return response()->json(['warning' => 'Order not found'], 200);
        } elseif ($order['label_url'] == null) {
            $street = $sender[0]->street; //'97 Quentin Rd, 1st Floor';
            $city = $sender[0]->city_name; // 'Brooklyn';
            $stateOrProvinceCode = $sender[0]->city_name; // 'NY';
            $postalCode = $sender[0]->zip; // '11223';
            $countryCode = 'US'; //'US';
            $weight = ($order['weight'] > 0) ? $order['weight'] : 1; // 20;


            $userCredential = new WebAuthenticationCredential();
            $userCredential
                ->setKey('2WrQK1IeH6jBoghg')
                ->setPassword('RFdr6uqXNvFpZVvwtoEaGLuRG');
            $webAuthenticationDetail = new WebAuthenticationDetail();
            $webAuthenticationDetail->setUserCredential($userCredential);
            $clientDetail = new ClientDetail();
            $clientDetail
                ->setAccountNumber('647927254')
                ->setMeterNumber('250557652');
            $version = new VersionId();
            $version
                ->setMajor(23)
                ->setIntermediate(0)
                ->setMinor(0)
                ->setServiceId('ship');
            $shipperAddress = new Address();
            $shipperAddress
                ->setStreetLines(['56 Christopher Columbus Dr'])
//                ->setStreetLines([$street])
                ->setCity('Jersey City')
//                ->setCity($city)
                ->setStateOrProvinceCode('NJ')
//                ->setStateOrProvinceCode($stateOrProvinceCode)
                ->setPostalCode('07302')
                ->setCountryCode('US');
            $shipperContact = new Contact();
            $shipperContact
//            ->setCompanyName('FAZO CARGO INC.')
//                ->setEMailAddress('test@example.com')
                ->setPersonName($sender[0]->firstname . ' ' . $sender[0]->secondname . ' ' . $sender[0]->fathername)
                ->setPhoneNumber(($sender[0]->phone));
            $shipper = new Party();
            $shipper
                ->setAccountNumber('250557652')
                ->setAddress($shipperAddress)
                ->setContact($shipperContact);
            $recipientAddress = new Address();
            $recipientAddress
                ->setStreetLines(['97 Quentin Rd, 1st floor'])
                ->setCity('Brooklyn')
                ->setStateOrProvinceCode('NY')
                ->setPostalCode('11223')
                ->setCountryCode('US');
            $recipientContact = new Contact();
            $recipientContact
                ->setCompanyName('FAZO CARGO INC.')
                ->setPersonName('Sheroz Mamayev')
                ->setPhoneNumber('+1 347 547.9797');
            $recipient = new Party();
            $recipient
                ->setAddress($recipientAddress)
                ->setContact($recipientContact);
            $labelSpecification = new LabelSpecification();
            $labelSpecification
                ->setLabelStockType(new LabelStockType(LabelStockType::_PAPER_7X4POINT75))
                ->setImageType(new ShippingDocumentImageType(ShippingDocumentImageType::_PDF))
                ->setLabelFormatType(new LabelFormatType(LabelFormatType::_COMMON2D));
            $packageLineItem1 = new RequestedPackageLineItem();
            $packageLineItem1
                ->setSequenceNumber(1)
                ->setItemDescription('Product description')
                ->setDimensions(new Dimensions(array(
                    'Width' => 10,
                    'Height' => 1,
                    'Length' => 1,
                    'Units' => LinearUnits::_CM
                )))
                ->setWeight(new Weight(array(
                    'Value' => $weight,
                    'Units' => WeightUnits::_KG
                )));
            $shippingChargesPayor = new Payor();
            $shippingChargesPayor->setResponsibleParty($shipper);
            $shippingChargesPayment = new Payment();
            $shippingChargesPayment
                ->setPaymentType(PaymentType::_SENDER)
                ->setPayor($shippingChargesPayor);
            $requestedShipment = new RequestedShipment();
            $requestedShipment->setShipTimestamp(date('c'));
            $requestedShipment->setDropoffType(new DropoffType(DropoffType::_REGULAR_PICKUP));
            $requestedShipment->setServiceType(new ServiceType(ServiceType::_FEDEX_GROUND));
            $requestedShipment->setPackagingType(new PackagingType(PackagingType::_YOUR_PACKAGING));
            $requestedShipment->setShipper($shipper);
            $requestedShipment->setRecipient($recipient);
            $requestedShipment->setLabelSpecification($labelSpecification);
            $requestedShipment->setRateRequestTypes(array(new RateRequestType(RateRequestType::_PREFERRED)));
            $requestedShipment->setPackageCount(1);
            $requestedShipment->setRequestedPackageLineItems([
                $packageLineItem1
            ]);
            $requestedShipment->setShippingChargesPayment($shippingChargesPayment);
            $processShipmentRequest = new ProcessShipmentRequest();
            $processShipmentRequest->setWebAuthenticationDetail($webAuthenticationDetail);
            $processShipmentRequest->setClientDetail($clientDetail);
            $processShipmentRequest->setVersion($version);
            $processShipmentRequest->setRequestedShipment($requestedShipment);
            $shipService = new Request();
//            dd($processShipmentRequest);
//            ini_set("soap.wsdl_cache_enabled", "0");
            $shipService->getSoapClient()->__setLocation(Request::PRODUCTION_URL);
//            $shipService->getSoapClient()->SoapClient('https://ws.fedex.com:443/web-services/ship');
//            $shipService->getSoapClient()->SoapClient('https://ws.fedex.com:443/web-services');
            $result = $shipService->getProcessShipmentReply($processShipmentRequest);

            if ($result->HighestSeverity == 'ERROR') {
                dd($result);
//                return response()->json([
//                    'error' => $result->Notifications[0]->Message,
//                    'code' => $result->Notifications[0]->Code
//                ], 200);
            }
            if ($result->HighestSeverity == 'WARNING') {
//                dd($result->Notifications[0]->Message);
                return response()->json([
                    'warning' => $result->Notifications[0]->Message,
                    'code' => $result->Notifications[0]->Code
                ], 200);
            }
            if ($result->HighestSeverity == 'SUCCESS') {
//                $file = file_get_contents($result->CompletedShipmentDetail->CompletedPackageDetails[0]->Label->Parts[0]->Image);
                $path = 'uploads';
                $path .= '/labels/';
                $filename = md5(time()) . date('Ymdhis') . '.pdf';
                file_put_contents(public_path($path . '/' . $filename), $result->CompletedShipmentDetail->CompletedPackageDetails[0]->Label->Parts[0]->Image);
                $order->label_url = $path . '/' . $filename;
                $order->save();
//                dd($order);
                return Response::download($order['label_url']);

            }
        } else {
            return Response::download($order['label_url']);
        }

    }

}
